﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridCaptionTest
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			var rnd = new Random();

			for (int i = 0; i < 50; i++)
			{
				ultraDataSource1.Rows.Add(new object[] { rnd.Next(100), rnd.Next(100), rnd.Next(100), rnd.Next(100), rnd.Next(100) });
			}
			ultraGrid1.CreationFilter = new GridCaptionCreationFilter();
		}
	}

	class GridCaptionCreationFilter : IUIElementCreationFilter
	{
		public void AfterCreateChildElements(UIElement parent)
		{
			if (parent is UltraGridUIElement)
			{
				var caption = parent.GetDescendant(typeof(CaptionAreaUIElement));
				var dataArea = parent.GetDescendant(typeof(DataAreaUIElement));

				var dataRect = dataArea.Rect;
				var captionRect = caption.Rect;

				dataRect.Y = caption.Rect.Y;
				captionRect.Y = dataArea.Rect.Bottom - caption.Rect.Height;

				dataArea.Rect = dataRect;
				caption.Rect = captionRect;

				parent.DirtyChildElements();
			}
		}

		public bool BeforeCreateChildElements(UIElement parent)
		{
			return false;
		}
	}
}
